# {{ ansible_managed }}
# Setup for {{ item.server_name }}, port 80
server {
  listen [::]:80;
  listen 80;
  server_name  {{ item.server_name }};
  location / {
    {% if 'docroot' in item -%}
    root {{ item.docroot }};
    {% endif -%}
    {% if 'ssl' in item and item.ssl == 'redirect' -%}
    # Backend configured using SSL, redirecting all http to https
    rewrite ^/(.*)$ https://{{ item.server_name }} permanent;
    {%- else -%}
    {% if 'uwsgi_socket' in item -%}
    include uwsgi_params;
    uwsgi_pass {{ item.uwsgi_socket }};
    {%- endif -%}
    {%- endif %}

  }
}

{% if item.ssl | default(False) %}
# Setup for {{ item.server_name }}, port 443
server {
  listen [::]:443 ssl http2;
  listen 443 ssl http2;
  server_name {{ item.server_name }};
  ssl_certificate {{ item.ssl_certificate | default('/etc/letsencrypt/live/' ~ item.server_name ~ '/fullchain.pem')}};
  ssl_certificate_key {{ item.ssl_private_key | default('/etc/letsencrypt/live/' ~ item.server_name ~ '/privkey.pem')}};

  access_log /var/log/nginx/{{ item.conf_name }}_access.log;
  error_log /var/log/nginx/{{ item.conf_name }}_error.log;


  location / {
    {% if 'auth_basic_file' in item -%}
    auth_basic "Auth for {{ item.server_name }}";
    auth_basic_user_file {{ item.auth_basic_file }};
    {% endif -%}
    {% if 'docroot' in item -%}
    root {{ item.docroot }};
    {% endif -%} 
    {% if 'uwsgi_socket' in item -%}
    include uwsgi_params;
    uwsgi_pass {{ item.uwsgi_socket }};
    {%- endif %}

  }

  {% if 'django_media' in item -%}
  location /media {
    root {{ item.docroot }};
  }
  
  {% endif -%}
  {% if 'django_static' in item -%}
  location /static {
    root {{ item.docroot }};
  }

  {% endif %}

  {% for option in item.custom_options | default([]) -%}
  {{ option }}
  {%- endfor %}

}
{% endif %}
